function [ T,qs] = sinvert( s0,p )
%  This function accepts saturation entropy, s0, and pressure 
% (hPa), and returns temperature (K), and saturation
% specific humidity (g/g)
%  Note:  This is not a very efficient algorithm
%
cp=1005;
ci=2000;
Rd=287;
Lv0=2.555e6;
Lf=3.34e5;
del=10;
pref=1000;
Tref=290;
tolerance=0.002;
%
%   First guess
%
Tg=280;
n=0;
while del > tolerance && n < 1000
    n=n+1;
    %
    Tgc=Tg-273.15;
    if Tgc > 0
        qi=0;
        esg=6.112*exp(17.67*Tgc/(243.5+Tgc));
    else
        esg=exp(23.33086-6111.72784/Tg+0.15215*log(Tg));
        qi=0.622*(6.112/(500-6.112)-esg/(p-esg));
        qi=max(qi,0);
    end    
    qsg=0.622*esg/max(p-esg,10);
    qsg=max(qsg,0);
    %Lv=Lv0+0.5e6*min(max(270-Tg,0),1);
    Lv=Lv0;
    T=Tref*exp((s0+Rd*log(p/pref)-Lv*qsg/Tg+Lf*qi/Tg)/(cp+qi*ci));
    del=abs(T-Tg);
    Tg=0.65*Tg+0.35*T;
end
T=Tg;
Tgc=Tg-273.15;
if Tgc > 0
    esg=6.112*exp(17.67*Tgc/(243.5+Tgc));
else
    esg=exp(23.33086-6111.72784/Tg+0.15215*log(Tg));
end    
qs=0.622*esg/(p-esg);
end

